diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/mtd-xip.h linux-2.6.x/include/asm-arm/arch-actelm7/mtd-xip.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/mtd-xip.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/mtd-xip.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,32 @@
+/*
+ * MTD primitives for XIP support. Architecture specific functions
+ *
+ * Do not include this file directly. It's included from linux/mtd/xip.h
+ * 
+ * Author:	Nicolas Pitre
+ * Created:	Nov 2, 2004
+ * Copyright:	(C) 2004 MontaVista Software, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * $Id: xip.h,v 1.2 2004/12/01 15:49:10 nico Exp $
+ */
+
+#ifndef __ARM_MTD_XIP_H__
+#define __ARM_MTD_XIP_H__
+
+#include <asm/hardware.h>
+#include <asm/arch/mtd-xip.h>
+
+#define xip_irqpending()	(IRQStatus)
+
+/* we sample OSCR and convert desired delta to usec (1/4 ~= 1000000/3686400) */
+#define xip_currtime()		(T0_VALUE)
+#define xip_elapsed_since(x)	(signed)((T0_VALUE - (x)) * 1000)
+
+/* fill instruction prefetch */
+#define xip_iprefetch() 	do { asm volatile (".rep 8; nop; .endr"); } while (0)
+
+#endif /* __ARM_MTD_XIP_H__ */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/param.h linux-2.6.x/include/asm-arm/arch-actelm7/param.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/param.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/param.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,9 @@
+#ifndef __ARCH_ASM_PARAM_H__
+#define __ARCH_ASM_PARAM_H__
+#endif
+
+#ifndef HZ
+#define HZ	100
+#endif 
+
+/* __ARCH_ASM_PARAM_H__ */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/serial.h linux-2.6.x/include/asm-arm/arch-actelm7/serial.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/serial.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/serial.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,34 @@
+/*
+ * include/asm-arm/arch-actelm7/serial.h
+ */
+
+#ifndef __ASM_ARCH_SERIAL_H__
+#define __ASM_ARCH_SERIAL_H__
+
+#include <asm/hardware.h>
+
+#define BASE_BAUD  (actelm7_Fpclk / 16)
+#define UART0_BASE  0x22000000
+
+/* Standard COM flags */
+#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST)
+
+#define RS_TABLE_SIZE 1
+
+/*
+ * Rather empty table...
+ * Hardwired serial ports should be defined here.
+ * PCMCIA will fill it dynamically.
+ */
+#define STD_SERIAL_PORT_DEFNS	\
+       /* UART	CLK     	PORT		IRQ	FLAGS		*/ \
+	{ 0,	BASE_BAUD,	UART0_BASE, 	1,	STD_COM_FLAGS,	\
+	.iomem_reg_shift = 2,		\
+	.iomem_base = UART0_BASE,	\
+	.io_type = UPIO_MEM},	\
+
+
+#define SERIAL_PORT_DFNS	\
+	STD_SERIAL_PORT_DEFNS
+
+#endif /* __ASM_ARCH_SERIAL_H__ */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/system.h linux-2.6.x/include/asm-arm/arch-actelm7/system.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/system.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/system.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,25 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/system.h
+ */
+#ifndef __ASM_ARCH_SYSTEM_H
+#define __ASM_ARCH_SYSTEM_H
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+
+
+static void arch_idle(void)
+{
+	cpu_do_idle();
+}
+
+static inline void arch_reset(char mode)
+{
+ 	/* machine should reboot */
+ 	mdelay(5000);
+ 	panic("Watchdog timer reset failed!\n");
+ 	printk(" Jump to address 0 \n");
+ 	cpu_reset(0);/*will jump to cpu_arm7_reset in proc-arm67.S,since actelm7 have no cache,we must modify the code*/
+}
+
+#endif
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/time.h linux-2.6.x/include/asm-arm/arch-actelm7/time.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/time.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/time.h	2009-09-12 17:44:20.000000000 +0100
@@ -0,0 +1,22 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/time.h
+ *
+ *  Copyright (C) 2004 Philips Semiconductors
+ */
+
+#ifndef __ASM_ARCH_TIME_H__
+#define __ASM_ARCH_TIME_H__
+
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <asm/hardware.h>
+#include <asm/arch/timex.h>
+
+#define CLOCKS_PER_USEC	(actelm7_Fpclk / 1000000)
+
+/* set timer to generate interrupt every 10ms */
+#define INIT_VALUE 0x186A0				
+#define PRESCALE_COUNTER_INIT_VALUE 0
+
+
+#endif /*__ASM_ARCH_TIME_H__*/
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/timex.h linux-2.6.x/include/asm-arm/arch-actelm7/timex.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/timex.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/timex.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,24 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/timex.h
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef __ASM_ARCH_TIMEX_H__
+#define __ASM_ARCH_TIMEX_H__
+
+#define CLOCK_TICK_RATE (CONFIG_ARM_CLK)
+
+#endif /* __ASM_ARCH_TIMEX_H__ */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/vmalloc.h linux-2.6.x/include/asm-arm/arch-actelm7/vmalloc.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/vmalloc.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/vmalloc.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,35 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/vmalloc.h
+ *
+ *  Copyright (C) 2000 Russell King. 
+ *  modified by steven taffs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/*
+ * Just any arbitrary offset to the start of the vmalloc VM area: the
+ * current 8MB value just means that there will be a 8MB "hole" after the
+ * physical memory until the kernel virtual memory starts.  That means that
+ * any out-of-bounds memory accesses will hopefully be caught.
+ * The vmalloc() routines leaves a hole of 4kB between each vmalloced
+ * area for the same reason. ;)
+ */
+#define MAX_actelm7_SDRAM_SIZE (0x10000000)
+
+#define VMALLOC_OFFSET	  (8*1024*1024)
+#define VMALLOC_START	  (((unsigned long)high_memory + VMALLOC_OFFSET) & ~(VMALLOC_OFFSET-1))
+#define VMALLOC_VMADDR(x) ((unsigned long)(x))
+#define VMALLOC_END       (PAGE_OFFSET + MAX_actelm7_SDRAM_SIZE)   
diff -Naur linux-2.6.11.8/include/asm-arm/cacheflush.h linux-2.6.x/include/asm-arm/cacheflush.h
--- linux-2.6.11.8/include/asm-arm/cacheflush.h	2009-09-06 22:49:58.000000000 +0100
+++ linux-2.6.x/include/asm-arm/cacheflush.h	2009-09-06 22:42:40.000000000 +0100
@@ -50,6 +50,14 @@
 # endif
 #endif
 
+#if defined(CONFIG_CPU_ACTELM7)
+# ifdef _CACHE
+#  define MULTI_CACHE 1
+# else
+#  define _CACHE actelm7
+# endif
+#endif
+
 #if defined(CONFIG_CPU_ARM920T) || defined(CONFIG_CPU_ARM922T) || \
     defined(CONFIG_CPU_ARM925T) || defined(CONFIG_CPU_ARM1020)
 # define MULTI_CACHE 1
diff -Naur linux-2.6.11.8/include/asm-arm/glue.h linux-2.6.x/include/asm-arm/glue.h
--- linux-2.6.11.8/include/asm-arm/glue.h	2009-09-06 22:49:58.000000000 +0100
+++ linux-2.6.x/include/asm-arm/glue.h	2009-09-06 22:42:40.000000000 +0100
@@ -51,7 +51,7 @@
 # endif
 #endif
 
-#if defined(CONFIG_CPU_ARM7TDMI) || defined(CONFIG_CPU_S3C4510B)
+#if defined(CONFIG_CPU_ARM7TDMI) || defined(CONFIG_CPU_S3C4510B) || defined(CONFIG_CPU_ACTELM7)
 # ifdef CPU_ABORT_HANDLER
 #  define MULTI_ABORT 1
 # else
diff -Naur linux-2.6.11.8/include/asm-arm/proc-fns.h linux-2.6.x/include/asm-arm/proc-fns.h
--- linux-2.6.11.8/include/asm-arm/proc-fns.h	2009-09-06 22:49:58.000000000 +0100
+++ linux-2.6.x/include/asm-arm/proc-fns.h	2009-09-06 22:42:40.000000000 +0100
@@ -67,6 +67,14 @@
 #   define CPU_NAME cpu_arm7
 #  endif
 # endif
+# ifdef CONFIG_CPU_ACTELM7
+#  ifdef CPU_NAME
+#   undef  MULTI_CPU
+#   define MULTI_CPU
+#  else
+#   define CPU_NAME cpu_arm7
+#  endif
+# endif
 # ifdef CONFIG_CPU_ARM720T
 #  ifdef CPU_NAME
 #   undef  MULTI_CPU
diff -Naur linux-2.6.11.8/include/asm-arm/unistd.h linux-2.6.x/include/asm-arm/unistd.h
--- linux-2.6.11.8/include/asm-arm/unistd.h	2005-04-30 02:31:50.000000000 +0100
+++ linux-2.6.x/include/asm-arm/unistd.h	2009-09-06 22:42:40.000000000 +0100
@@ -152,9 +152,11 @@
 #define __NR_adjtimex			(__NR_SYSCALL_BASE+124)
 #define __NR_mprotect			(__NR_SYSCALL_BASE+125)
 #define __NR_sigprocmask		(__NR_SYSCALL_BASE+126)
+#define __NR_create_module		(__NR_SYSCALL_BASE+127) /*added for ACTELM7*/
 					/* 127 was sys_create_module */
 #define __NR_init_module		(__NR_SYSCALL_BASE+128)
 #define __NR_delete_module		(__NR_SYSCALL_BASE+129)
+#define __NR_get_kernel_syms		(__NR_SYSCALL_BASE+130) /*added for ACTELM7*/
 					/* 130 was sys_get_kernel_syms */
 #define __NR_quotactl			(__NR_SYSCALL_BASE+131)
 #define __NR_getpgid			(__NR_SYSCALL_BASE+132)
diff -Naur linux-2.6.11.8/include/linux/mtd/xip.h linux-2.6.x/include/linux/mtd/xip.h
--- linux-2.6.11.8/include/linux/mtd/xip.h	2005-04-30 02:29:45.000000000 +0100
+++ linux-2.6.x/include/linux/mtd/xip.h	2009-09-06 22:42:40.000000000 +0100
@@ -19,6 +19,7 @@
 #define __LINUX_MTD_XIP_H__
 
 #include <linux/config.h>
+#include <asm/hardware.h>
 
 #ifdef CONFIG_MTD_XIP
 
@@ -27,7 +28,7 @@
  * obviously not be running from flash.  The __xipram is therefore marking
  * those functions so they get relocated to ram.
  */
-#define __xipram __attribute__ ((__section__ (".data")))
+#define __xipram __attribute__ ((long_call,__section__ (".data")))
 
 /*
  * We really don't want gcc to guess anything.
@@ -75,13 +76,22 @@
 
 #else
 
-#warning "missing IRQ and timer primitives for XIP MTD support"
-#warning "some of the XIP MTD support code will be disabled"
-#warning "your system will therefore be unresponsive when writing or erasing flash"
-
-#define xip_irqpending()	(0)
-#define xip_currtime()		(0)
-#define xip_elapsed_since(x)	(0)
+//#warning "missing IRQ and timer primitives for XIP MTD support"
+//#warning "some of the XIP MTD support code will be disabled"
+//#warning "your system will therefore be unresponsive when writing or erasing flash"
+
+//#define xip_irqpending()	(0)
+//#define xip_currtime()		(0)
+//#define xip_elapsed_since(x)	(0)
+
+#define xip_irqpending()	(IRQStatus)
+
+/* we sample OSCR and convert desired delta to usec (1/4 ~= 1000000/3686400) */
+#define xip_currtime()		(T0_VALUE)
+#define xip_elapsed_since(x)	(signed)((T0_VALUE - (x)) * 1000)
+
+/* fill instruction prefetch */
+#define xip_iprefetch() 	do { asm volatile (".rep 8; nop; .endr"); } while (0)
 
 #endif
 
diff -Naur linux-2.6.11.8/include/linux/slab.h linux-2.6.x/include/linux/slab.h
--- linux-2.6.11.8/include/linux/slab.h	2005-04-30 02:32:41.000000000 +0100
+++ linux-2.6.x/include/linux/slab.h	2009-09-06 22:42:40.000000000 +0100
@@ -44,7 +44,7 @@
 #define SLAB_MUST_HWCACHE_ALIGN	0x00008000UL	/* force alignment */
 #define SLAB_STORE_USER		0x00010000UL	/* store the last owner for bug hunting */
 #define SLAB_RECLAIM_ACCOUNT	0x00020000UL	/* track pages allocated to indicate
-						   what is reclaimable later*/
+						   what is reclaimable later */
 #define SLAB_PANIC		0x00040000UL	/* panic if kmem_cache_create() fails */
 #define SLAB_DESTROY_BY_RCU	0x00080000UL	/* defer freeing pages to RCU */
 
@@ -53,6 +53,9 @@
 #define SLAB_CTOR_ATOMIC	0x002UL		/* tell constructor it can't sleep */
 #define	SLAB_CTOR_VERIFY	0x004UL		/* tell constructor it's a verify call */
 
+
+#ifndef CONFIG_SLOB
+
 /* prototypes */
 extern void __init kmem_cache_init(void);
 
@@ -112,6 +115,36 @@
 extern int FASTCALL(kmem_cache_reap(int));
 extern int FASTCALL(kmem_ptr_validate(kmem_cache_t *cachep, void *ptr));
 
+#else /* CONFIG_SLOB */
+
+/* SLOB allocator routines */
+
+void kmem_cache_init(void);
+kmem_cache_t *kmem_find_general_cachep(size_t, gfp_t gfpflags);
+kmem_cache_t *kmem_cache_create(const char *c, size_t, size_t, unsigned long,void (*)(void *, kmem_cache_t *, unsigned long),void (*)(void *, kmem_cache_t *, unsigned long));
+int kmem_cache_destroy(kmem_cache_t *c);
+void *kmem_cache_alloc(kmem_cache_t *c, gfp_t flags);
+void kmem_cache_free(kmem_cache_t *c, void *b);
+const char *kmem_cache_name(kmem_cache_t *);
+void *kmalloc(size_t size, gfp_t flags);
+void *kzalloc(size_t size, gfp_t flags);
+void kfree(const void *m);
+unsigned int ksize(const void *m);
+unsigned int kmem_cache_size(kmem_cache_t *c);
+
+static inline void *kcalloc(size_t n, size_t size, gfp_t flags)
+{
+	return kzalloc(n * size, flags);
+}
+
+#define kmem_cache_shrink(d) (0)
+#define kmem_cache_reap(a)
+#define kmem_ptr_validate(a, b) (0)
+#define kmem_cache_alloc_node(c, f, n) kmem_cache_alloc(c, f)
+#define kmalloc_node(s, f, n) kmalloc(s, f)
+
+#endif /* CONFIG_SLOB */
+
 /* System wide caches */
 extern kmem_cache_t	*vm_area_cachep;
 extern kmem_cache_t	*mm_cachep;
diff -Naur linux-2.6.11.8/include/linux/types.h linux-2.6.x/include/linux/types.h
--- linux-2.6.11.8/include/linux/types.h	2005-04-30 02:31:20.000000000 +0100
+++ linux-2.6.x/include/linux/types.h	2009-09-06 22:42:40.000000000 +0100
@@ -162,6 +162,8 @@
 typedef __u64 __bitwise __be64;
 #endif
 
+typedef unsigned __bitwise gfp_t;
+
 struct ustat {
 	__kernel_daddr_t	f_tfree;
 	__kernel_ino_t		f_tinode;
diff -Naur linux-2.6.11.8/init/do_mounts.c linux-2.6.x/init/do_mounts.c
--- linux-2.6.11.8/init/do_mounts.c	2005-04-30 02:26:32.000000000 +0100
+++ linux-2.6.x/init/do_mounts.c	2009-09-06 22:42:40.000000000 +0100
@@ -289,9 +289,19 @@
 	char b[BDEVNAME_SIZE];
 
 	get_fs_names(fs_names);
+
+	/*printk("*****\nVFS: test  name = <%s> \n",name);
+	for (p = fs_names; *p; p +=strlen(p)+1)
+	{
+		printk("VFS: fs_name = <%s> \n",p);
+	}
+	printk("VFS: root name <%s> \n ******\n",kdevname(ROOT_DEV)); */
 retry:
 	for (p = fs_names; *p; p += strlen(p)+1) {
 		int err = do_mount_root(name, p, flags, root_mount_data);
+		
+		/*printk("VFS: tried fs_name = <%s> err %d\n",p,err); */
+		
 		switch (err) {
 			case 0:
 				goto out;
diff -Naur linux-2.6.11.8/init/Kconfig linux-2.6.x/init/Kconfig
--- linux-2.6.11.8/init/Kconfig	2009-09-06 22:49:58.000000000 +0100
+++ linux-2.6.x/init/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -352,6 +352,15 @@
 	  no dummy operations need be executed.
 	  Zero means use compiler's default.
 
+config SLAB
+	default y
+	bool "Use full SLAB allocator" if EMBEDDED
+	help
+	  Disabling this replaces the advanced SLAB allocator and
+	  kmalloc support with the drastically simple SLOB allocator
+	  SLOB is more space efficient but does not scale well and is
+	  more susceptible to fragmentation.
+
 endmenu		# General setup
 
 config TINY_SHMEM
@@ -359,6 +368,10 @@
 	depends MMU
 	bool
 
+config SLOB
+	default !SLAB
+	bool
+
 menu "Loadable module support"
 
 config MODULES
diff -Naur linux-2.6.11.8/kernel/printk.c linux-2.6.x/kernel/printk.c
--- linux-2.6.11.8/kernel/printk.c	2005-04-30 02:32:46.000000000 +0100
+++ linux-2.6.x/kernel/printk.c	2009-09-06 22:42:40.000000000 +0100
@@ -518,9 +518,17 @@
 	int r;
 
 	va_start(args, fmt);
+	
+	//U0RBR = 0x3b;			//11
+
 	r = vprintk(fmt, args);
+	
+	//U0RBR = 0x43;			//18
+
 	va_end(args);
 
+	//U0RBR = 0x44;			//19
+
 	return r;
 }
 
@@ -532,15 +540,21 @@
 	static char printk_buf[1024];
 	static int log_level_unknown = 1;
 
+	//U0RBR = 0x3c;			//12
+
 	if (unlikely(oops_in_progress))
 		zap_locks();
 
 	/* This stops the holder of console_sem just where we want him */
 	spin_lock_irqsave(&logbuf_lock, flags);
 
+	//U0RBR = 0x3d;			//13
+
 	/* Emit the output into the temporary buffer */
 	printed_len = vscnprintf(printk_buf, sizeof(printk_buf), fmt, args);
 
+	//U0RBR = 0x3e;			//14
+
 	/*
 	 * Copy the output into log_buf.  If the caller didn't provide
 	 * appropriate log level tags, we insert them here
@@ -559,6 +573,8 @@
 			log_level_unknown = 1;
 	}
 
+	//U0RBR = 0x3f;			//15
+
 	if (!cpu_online(smp_processor_id()) &&
 	    system_state != SYSTEM_RUNNING) {
 		/*
@@ -570,6 +586,9 @@
 		spin_unlock_irqrestore(&logbuf_lock, flags);
 		goto out;
 	}
+
+	//U0RBR = 0x40;			//16
+
 	if (!down_trylock(&console_sem)) {
 		console_locked = 1;
 		/*
@@ -580,6 +599,9 @@
 		console_may_schedule = 0;
 		release_console_sem();
 	} else {
+
+	//U0RBR = 0x41;			//17
+
 		/*
 		 * Someone else owns the drivers.  We drop the spinlock, which
 		 * allows the semaphore holder to proceed and to call the
@@ -588,6 +610,7 @@
 		spin_unlock_irqrestore(&logbuf_lock, flags);
 	}
 out:
+	//U0RBR = 0x42;			//18
 	return printed_len;
 }
 EXPORT_SYMBOL(printk);
diff -Naur linux-2.6.11.8/mm/Makefile linux-2.6.x/mm/Makefile
--- linux-2.6.11.8/mm/Makefile	2005-04-30 02:29:07.000000000 +0100
+++ linux-2.6.x/mm/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -9,7 +9,7 @@
 
 obj-y			:= bootmem.o filemap.o mempool.o oom_kill.o fadvise.o \
 			   page_alloc.o page-writeback.o pdflush.o \
-			   readahead.o slab.o swap.o truncate.o vmscan.o \
+			   readahead.o swap.o truncate.o vmscan.o \
 			   prio_tree.o $(mmu-y)
 
 obj-$(CONFIG_SWAP)	+= page_io.o swap_state.o swapfile.o thrash.o
@@ -17,4 +17,5 @@
 obj-$(CONFIG_NUMA) 	+= mempolicy.o
 obj-$(CONFIG_SHMEM) += shmem.o
 obj-$(CONFIG_TINY_SHMEM) += tiny-shmem.o
-
+obj-$(CONFIG_SLOB)	+= slob.o
+obj-$(CONFIG_SLAB)	+= slab.o
diff -Naur linux-2.6.11.8/mm/slob.c linux-2.6.x/mm/slob.c
--- linux-2.6.11.8/mm/slob.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/mm/slob.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,395 @@
+/*
+ * SLOB Allocator: Simple List Of Blocks
+ *
+ * Matt Mackall <mpm@selenic.com> 12/30/03
+ *
+ * How SLOB works:
+ *
+ * The core of SLOB is a traditional K&R style heap allocator, with
+ * support for returning aligned objects. The granularity of this
+ * allocator is 8 bytes on x86, though it's perhaps possible to reduce
+ * this to 4 if it's deemed worth the effort. The slob heap is a
+ * singly-linked list of pages from __get_free_page, grown on demand
+ * and allocation from the heap is currently first-fit.
+ *
+ * Above this is an implementation of kmalloc/kfree. Blocks returned
+ * from kmalloc are 8-byte aligned and prepended with a 8-byte header.
+ * If kmalloc is asked for objects of PAGE_SIZE or larger, it calls
+ * __get_free_pages directly so that it can return page-aligned blocks
+ * and keeps a linked list of such pages and their orders. These
+ * objects are detected in kfree() by their page alignment.
+ *
+ * SLAB is emulated on top of SLOB by simply calling constructors and
+ * destructors for every SLAB allocation. Objects are returned with
+ * the 8-byte alignment unless the SLAB_MUST_HWCACHE_ALIGN flag is
+ * set, in which case the low-level allocator will fragment blocks to
+ * create the proper alignment. Again, objects of page-size or greater
+ * are allocated by calling __get_free_pages. As SLAB objects know
+ * their size, no separate size bookkeeping is necessary and there is
+ * essentially no allocation space overhead.
+ */
+
+#include <linux/config.h>
+#include <linux/slab.h>
+#include <linux/mm.h>
+#include <linux/cache.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/timer.h>
+
+struct slob_block {
+	int units;
+	struct slob_block *next;
+};
+typedef struct slob_block slob_t;
+
+#define SLOB_UNIT sizeof(slob_t)
+#define SLOB_UNITS(size) (((size) + SLOB_UNIT - 1)/SLOB_UNIT)
+#define SLOB_ALIGN L1_CACHE_BYTES
+
+struct bigblock {
+	int order;
+	void *pages;
+	struct bigblock *next;
+};
+typedef struct bigblock bigblock_t;
+
+static slob_t arena = { .next = &arena, .units = 1 };
+static slob_t *slobfree = &arena;
+static bigblock_t *bigblocks;
+static DEFINE_SPINLOCK(slob_lock);
+static DEFINE_SPINLOCK(block_lock);
+
+static void slob_free(void *b, int size);
+
+static void *slob_alloc(size_t size, gfp_t gfp, int align)
+{
+	slob_t *prev, *cur, *aligned = 0;
+	int delta = 0, units = SLOB_UNITS(size);
+	unsigned long flags;
+
+	spin_lock_irqsave(&slob_lock, flags);
+	prev = slobfree;
+	for (cur = prev->next; ; prev = cur, cur = cur->next) {
+		if (align) {
+			aligned = (slob_t *)ALIGN((unsigned long)cur, align);
+			delta = aligned - cur;
+		}
+		if (cur->units >= units + delta) { /* room enough? */
+			if (delta) { /* need to fragment head to align? */
+				aligned->units = cur->units - delta;
+				aligned->next = cur->next;
+				cur->next = aligned;
+				cur->units = delta;
+				prev = cur;
+				cur = aligned;
+			}
+
+			if (cur->units == units) /* exact fit? */
+				prev->next = cur->next; /* unlink */
+			else { /* fragment */
+				prev->next = cur + units;
+				prev->next->units = cur->units - units;
+				prev->next->next = cur->next;
+				cur->units = units;
+			}
+
+			slobfree = prev;
+			spin_unlock_irqrestore(&slob_lock, flags);
+			return cur;
+		}
+		if (cur == slobfree) {
+			spin_unlock_irqrestore(&slob_lock, flags);
+
+			if (size == PAGE_SIZE) /* trying to shrink arena? */
+				return 0;
+
+			cur = (slob_t *)__get_free_page(gfp);
+			if (!cur)
+				return 0;
+
+			slob_free(cur, PAGE_SIZE);
+			spin_lock_irqsave(&slob_lock, flags);
+			cur = slobfree;
+		}
+	}
+}
+
+static void slob_free(void *block, int size)
+{
+	slob_t *cur, *b = (slob_t *)block;
+	unsigned long flags;
+
+	if (!block)
+		return;
+
+	if (size)
+		b->units = SLOB_UNITS(size);
+
+	/* Find reinsertion point */
+	spin_lock_irqsave(&slob_lock, flags);
+	for (cur = slobfree; !(b > cur && b < cur->next); cur = cur->next)
+		if (cur >= cur->next && (b > cur || b < cur->next))
+			break;
+
+	if (b + b->units == cur->next) {
+		b->units += cur->next->units;
+		b->next = cur->next->next;
+	} else
+		b->next = cur->next;
+
+	if (cur + cur->units == b) {
+		cur->units += b->units;
+		cur->next = b->next;
+	} else
+		cur->next = b;
+
+	slobfree = cur;
+
+	spin_unlock_irqrestore(&slob_lock, flags);
+}
+
+static int FASTCALL(find_order(int size));
+static int fastcall find_order(int size)
+{
+	int order = 0;
+	for ( ; size > 4096 ; size >>=1)
+		order++;
+	return order;
+}
+
+void *kmalloc(size_t size, gfp_t gfp)
+{
+	slob_t *m;
+	bigblock_t *bb;
+	unsigned long flags;
+
+	if (size < PAGE_SIZE - SLOB_UNIT) {
+		m = slob_alloc(size + SLOB_UNIT, gfp, 0);
+		return m ? (void *)(m + 1) : 0;
+	}
+
+	bb = slob_alloc(sizeof(bigblock_t), gfp, 0);
+	if (!bb)
+		return 0;
+
+	bb->order = find_order(size);
+	bb->pages = (void *)__get_free_pages(gfp, bb->order);
+
+	if (bb->pages) {
+		spin_lock_irqsave(&block_lock, flags);
+		bb->next = bigblocks;
+		bigblocks = bb;
+		spin_unlock_irqrestore(&block_lock, flags);
+		return bb->pages;
+	}
+
+	slob_free(bb, sizeof(bigblock_t));
+	return 0;
+}
+
+EXPORT_SYMBOL(kmalloc);
+
+void *kzalloc(size_t size, gfp_t flags)
+{
+	void *ret = kmalloc(size, flags);
+	if (ret)
+		memset(ret, 0, size);
+	return ret;
+}
+
+EXPORT_SYMBOL(kzalloc);
+
+void kfree(const void *block)
+{
+	bigblock_t *bb, **last = &bigblocks;
+	unsigned long flags;
+
+	if (!block)
+		return;
+
+	if (!((unsigned int)block & (PAGE_SIZE-1))) {
+		/* might be on the big block list */
+		spin_lock_irqsave(&block_lock, flags);
+		for (bb = bigblocks; bb; last = &bb->next, bb = bb->next) {
+			if (bb->pages == block) {
+				*last = bb->next;
+				spin_unlock_irqrestore(&block_lock, flags);
+				free_pages((unsigned long)block, bb->order);
+				slob_free(bb, sizeof(bigblock_t));
+				return;
+			}
+		}
+		spin_unlock_irqrestore(&block_lock, flags);
+	}
+
+	slob_free((slob_t *)block - 1, 0);
+	return;
+}
+
+EXPORT_SYMBOL(kfree);
+
+unsigned int ksize(const void *block)
+{
+	bigblock_t *bb;
+	unsigned long flags;
+
+	if (!block)
+		return 0;
+
+	if (!((unsigned int)block & (PAGE_SIZE-1))) {
+		spin_lock_irqsave(&block_lock, flags);
+		for (bb = bigblocks; bb; bb = bb->next)
+			if (bb->pages == block) {
+				spin_unlock_irqrestore(&slob_lock, flags);
+				return PAGE_SIZE << bb->order;
+			}
+		spin_unlock_irqrestore(&block_lock, flags);
+	}
+
+	return ((slob_t *)block - 1)->units * SLOB_UNIT;
+}
+
+struct kmem_cache_s {
+	unsigned int size, align;
+	const char *name;
+	void (*ctor)(void *, kmem_cache_t *, unsigned long);
+	void (*dtor)(void *, kmem_cache_t *, unsigned long);
+};
+
+kmem_cache_t *kmem_cache_create(const char *name, size_t size, size_t align,
+	unsigned long flags,
+	void (*ctor)(void*, kmem_cache_t *, unsigned long),
+	void (*dtor)(void*, kmem_cache_t *, unsigned long))
+{
+	kmem_cache_t *c;
+
+	c = slob_alloc(sizeof(kmem_cache_t), flags, 0);
+
+	if (c) {
+		c->name = name;
+		c->size = size;
+		c->ctor = ctor;
+		c->dtor = dtor;
+		/* ignore alignment unless it's forced */
+		c->align = (flags & SLAB_MUST_HWCACHE_ALIGN) ? SLOB_ALIGN : 0;
+		if (c->align < align)
+			c->align = align;
+	}
+
+	return c;
+}
+EXPORT_SYMBOL(kmem_cache_create);
+
+int kmem_cache_destroy(kmem_cache_t *c)
+{
+	slob_free(c, sizeof(kmem_cache_t));
+	return 0;
+}
+EXPORT_SYMBOL(kmem_cache_destroy);
+
+void *kmem_cache_alloc(kmem_cache_t *c, gfp_t flags)
+{
+	void *b;
+
+	if (c->size < PAGE_SIZE)
+		b = slob_alloc(c->size, flags, c->align);
+	else
+		b = (void *)__get_free_pages(flags, find_order(c->size));
+
+	if (c->ctor)
+		c->ctor(b, c, SLAB_CTOR_CONSTRUCTOR);
+
+	return b;
+}
+EXPORT_SYMBOL(kmem_cache_alloc);
+
+void kmem_cache_free(kmem_cache_t *c, void *b)
+{
+	if (c->dtor)
+		c->dtor(b, c, 0);
+
+	if (c->size < PAGE_SIZE)
+		slob_free(b, c->size);
+	else
+		free_pages((unsigned long)b, find_order(c->size));
+}
+EXPORT_SYMBOL(kmem_cache_free);
+
+unsigned int kmem_cache_size(kmem_cache_t *c)
+{
+	return c->size;
+}
+EXPORT_SYMBOL(kmem_cache_size);
+
+const char *kmem_cache_name(kmem_cache_t *c)
+{
+	return c->name;
+}
+EXPORT_SYMBOL(kmem_cache_name);
+
+static struct timer_list slob_timer = TIMER_INITIALIZER(
+	(void (*)(unsigned long))kmem_cache_init, 0, 0);
+
+void kmem_cache_init(void)
+{
+	void *p = slob_alloc(PAGE_SIZE, 0, PAGE_SIZE-1);
+
+	if (p)
+		free_page((unsigned int)p);
+
+	mod_timer(&slob_timer, jiffies + HZ);
+}
+
+atomic_t slab_reclaim_pages = ATOMIC_INIT(0);
+EXPORT_SYMBOL(slab_reclaim_pages);
+
+#ifdef CONFIG_SMP
+
+void *__alloc_percpu(size_t size, size_t align)
+{
+	int i;
+	struct percpu_data *pdata = kmalloc(sizeof (*pdata), GFP_KERNEL);
+
+	if (!pdata)
+		return NULL;
+
+	for (i = 0; i < NR_CPUS; i++) {
+		if (!cpu_possible(i))
+			continue;
+		pdata->ptrs[i] = kmalloc(size, GFP_KERNEL);
+		if (!pdata->ptrs[i])
+			goto unwind_oom;
+		memset(pdata->ptrs[i], 0, size);
+	}
+
+	/* Catch derefs w/o wrappers */
+	return (void *) (~(unsigned long) pdata);
+
+unwind_oom:
+	while (--i >= 0) {
+		if (!cpu_possible(i))
+			continue;
+		kfree(pdata->ptrs[i]);
+	}
+	kfree(pdata);
+	return NULL;
+}
+EXPORT_SYMBOL(__alloc_percpu);
+
+void
+free_percpu(const void *objp)
+{
+	int i;
+	struct percpu_data *p = (struct percpu_data *) (~(unsigned long) objp);
+
+	for (i = 0; i < NR_CPUS; i++) {
+		if (!cpu_possible(i))
+			continue;
+		kfree(p->ptrs[i]);
+	}
+	kfree(p);
+}
+EXPORT_SYMBOL(free_percpu);
+
+#endif
\ No newline at end of file
